#include <WinHttp.au3>

Func _MIME_GET_Extension($MIME_CONTENT_TYPE)
	Local $MIME_TYPE = StringRegExp($MIME_CONTENT_TYPE,'\A(.*?)(;|$)',1)
	If Not IsArray($MIME_TYPE) Then
		Return ""
	Else
		$MIME_TYPE = $MIME_TYPE[0]
	EndIf
	$Extension = RegRead("HKEY_CLASSES_ROOT\MIME\Database\Content Type\"&$MIME_TYPE,"Extension")
	If @error Then
		If $MIME_TYPE = "application/x-msdownload" Then
			Return "exe"
		Else
			Local $MIME_MAIN_TYPE = StringRegExp($MIME_TYPE,'\A(.*?)\/',1)
			If Not IsArray($MIME_MAIN_TYPE) Then
				Return ""
			Else
				Return $MIME_MAIN_TYPE[0]
			EndIf
		EndIf
	Else
		Return $Extension
	EndIf
EndFunc

Func _Save_Response($iRequest,$Open = True)
Local $Respone_Content_Disposition = _WinHttpQueryHeaders(Eval("hRequest"&$iRequest),$WINHTTP_QUERY_CONTENT_DISPOSITION)
If $Respone_Content_Disposition <> "" Then
Local $file_name = StringRegExp($Respone_Content_Disposition,"filename=(.*?)$",1)
	If IsArray($file_name) Then
		$file_name = $file_name[0]
	EndIf
Else
	Local $Respone_Content_Type = _WinHttpQueryHeaders(Eval("hRequest"&$iRequest),$WINHTTP_QUERY_CONTENT_TYPE)
	If $Respone_Content_Type = "" Then
		$file_name = "HTTP_MESSAGE_RESPONE_Request_"&$iRequest
	Else
		Local $Ext = _MIME_GET_Extension($Respone_Content_Type)
		$file_name = "HTTP_MESSAGE_RESPONE_Request_"&$iRequest&$Ext
	EndIf
EndIf
Local $Data1
$Data1 = _WinHttpSimpleReadData(Eval("hRequest"&$iRequest), 2)

Local $respone_file = @TempDir & "\"&$file_name

Local $fopen = FileOpen($respone_file, 26 + 256)
FileWrite($fopen, $Data1)
FileClose($fopen)
$Data1 = BinaryToString($Data1,4)
If $Open Then ShellExecute($respone_file)
Return $respone_file
EndFunc